// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__4CBA9EA8_BF9D_4EF9_9E4F_ECD1FBBC10CB__INCLUDED_)
#define AFX_CHILDVIEW_H__4CBA9EA8_BF9D_4EF9_9E4F_ECD1FBBC10CB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#include "Model.h"
#include "KeyframeInterpolator.h"
#include "DebugDialog.h"
#include "LocalRemoteModel.h"
#include "Communication.h"
#include "Win32Timer.h"
#include "AnimSequence.h"
#include "DirectInput.h"
#include "InputDevice.h"
#include "InputManager.h"
#include "CameraView.h"
#include "constants.h"
#include "MainMode.h"
#include "Judge.h"
#include <assert.h>

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CWnd
{
friend class CCameraView; // s ni kamavadime, aby nam mohla posilat svoje spravy (tlacitka,...)

protected:
	CCameraView	*m_camera[cMaxCameras];	 // pole kamer, nebo NULLu

protected:
	CFrameWnd *m_owner;
	CWinApp	  *m_thisapp;
// Construction
public:
	CChildView(CFrameWnd *owner, CWinApp *thisapp);
	//void setOwner(CFrameWnd *owner) { m_owner = owner; } // presunuto do konstruktoru
	// funkce co bude zavolana hned po vytvoreni okna MainFrame:
	void afterWindowCreation();

// Attributes
public:

// Operations
protected:
	void colRespSave();
	void replay();	
	void animTest();
	void curvatureTest();
	void viewer();

public:
	//void selectInput(int typ);
	void mainLoop();

	// naloaduje textury podle aktualniho stavu m_mode, pozije kody textur pro kameru camId:
	void reloadTextures(int camId);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void destroyCamera(int camId);
	void mainDraw(CCameraView *camera, int camId, const bool transpAvatar[2]);
	virtual ~CChildView();

	CServerSocket const *getSS() { return m_ss; }

	bool isConnected() { return (m_cs!=0)||(m_ss!=0); }

private:
	CMainMode	*m_mode;

	//bool	m_drawFadingTriangles; // kreslime stiny mecu?
	//bool		fullscreen;
	//int		m_inputDevice; // mys nebo joystick	

	int			  m_netStatus; // 0 = nic, 1 = server, 2 = klient
	CServerSocket *m_ss;
	CCommSocket   *m_cs;

	HGLRC		hRC;		// Permanent Rendering Context	
	DebugDialog	m_dbgDialog;
	bool	m_dbgDialogActive;

	double		pos_z, pos_y, pos_x;

	Win32Timer	m_timer;

	// vstupni zarizeni a jejich manazer:
	CDirectInput		*m_di;
	CMouseInputDevice	*m_mid;
	InputManager		*m_inputManager;

	// kvuli testu curvatury:
//	KeyframeInterpolator *m_pAnim;

public:
	void OnButtonSelect(int joy);
	void initMode(int mod);
	// 'code' ma vyznam: -2 pro nic, -1 pro mys, joysticky jsou 0, 1, ...
	// 'remote' znamena vzdalene ovladani (InputEventy po siti):
	void setInputDevice(int player, int code, bool remote);
	void Disconnect();
	InputManager *getInputManager() { return m_inputManager; }
	int getMyState() { return m_mode->getMyState(); }
	FencerModel *getModel(int i) {
		assert(m_mode);
		return m_mode->getModel(i);
		//if (m_myState == cSimulate) return m_locModel[i]; 
		//else if (m_myState == cReplay) return m_remoteModel[i];
		//else return m_locModel[0]; // uvidime, co to udela :-)
	}
	void subdivCheck(bool checked);
	void onClientInit(int quality); // to mi zavola CCommSocket, az dostane inic. zpravu (s informaci o kvalite modelu)
	void onClientFailed();

protected:
	int	m_quality; // subdivided?
//	void processMouseMove();
//	void processJoystick();
//	void testCol(bool &t1t2, bool &t1z2, bool &t2z1); // internal collision test
//	bool *m_pTr[2]; // kolidujici trojuhelniky obou sermiru
	// nastavi silu pro hrace 'h':
//	void setForce(int h);

	// Generated message map functions
protected:
	void resizeDebugDialog();
	//{{AFX_MSG(CChildView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnNetworkListenserver();	
	afx_msg void OnNetworkConnectclient();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMainNewcamera();	
	afx_msg void OnButtonStartJudge();
	afx_msg void OnMainStartjudge();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__4CBA9EA8_BF9D_4EF9_9E4F_ECD1FBBC10CB__INCLUDED_)
