/* 
    Judge.h

	Automatic fencing judge.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#ifndef JUDGE_H
#define JUDGE_H

#include "Win32Timer.h"

// kody vypisovanych zprav (pro prenaseni po siti):
//enum {
//	cJM_Nonec = 0, cJM_EnGuard, cJM_Go, cJM_Stop, cJM_DoubleHit, cJM_Avatar0Hit,
//	cJM_Avatar1Hit, cJM_InvalidHit, cJM_Last
//};
//
//extern char *JMtext[cJM_Last];

// stavy rozhodciho:
const cJudgeNotInit = 0, cJudgeEnGuard = 1, cJudgeGo = 2, cJudgeBodyBody = 3, cJudgeHit = 4;
const cJudgeMessageTime = 2000;

class CJudge 
{
protected:
	CString	    m_text; // text co se ma zobrazovat v kazdem okne (neni-li NULL)
	CString		m_score; // skore v textove podobe
	Win32Timer	m_timer;	
	int			m_state; // stav rozhodciho (cJudge...)
	int			m_strehy; // i-ty bit nastaven = hrac i ve strehu
	void	   *m_simulation; // tomu se bude rikat, ze ma vratit sermire na stred (musi to byt CModeSimulation)
	int			m_body[2]; // pocitadlo zasahu

	// zkontroluje timer a kdyztak prejde do jineho stavu
	void testTime();

public:
	CJudge(void *mode);
	virtual ~CJudge();
	// vraci text pro okna
	const CString &getText();
	// vraci skore:
	const CString &getScore();
	// nastavi integerove skore:
	void getIntScore(int &s1, int &s2) { s1 = m_body[0]; s2 = m_body[1]; }

// zpravy co chodi od vselijakych trid:
	// ma se spustit cinnost rozhodciho, 'reset' - resetovat pocitadlo?:
	void start(bool reset = true);	
	// info ze avatar 'h' presel do strehu:
	void inGuard(int h);
	// zprava ze doslo ke kontaktu tel:
	void bodybody();
	// zprava o zasahu semire h0 nebo h1 (klidne i oba soucasne):
	void hit(bool h0, bool h1);

};

#endif
