// KeyboardConfigDialog.cpp : implementation file
//

#include "stdafx.h"
#include "gl1.h"
#include "KeyboardConfigDialog.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeyboardConfigDialog dialog


CKeyboardConfigDialog::CKeyboardConfigDialog(InputManager *im, CWnd* pParent /*=NULL*/)
	: CDialog(CKeyboardConfigDialog::IDD, pParent)
{
	m_inputManager = im;
	m_choosingPlayer = -1;

	// okopcim si stavajici nastaveni klaves z InputManagera:
	for (int h=0; h<2; h++)
	{
		for (int n=0; n<cPocetAkci; n++)
		{
			m_vk[h][n] = im->getKeyboardConfig(h, n);
		}
	}

	//{{AFX_DATA_INIT(CKeyboardConfigDialog)
	//}}AFX_DATA_INIT
}


void CKeyboardConfigDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyboardConfigDialog)
	DDX_Control(pDX, IDC_BACK1, m_back1edit);
	DDX_Control(pDX, IDC_PASS1, m_pass1edit);
	DDX_Control(pDX, IDC_FORWARD1, m_forward1edit);
	DDX_Control(pDX, IDC_GUARD1, m_guard1edit);
	DDX_Control(pDX, IDC_BACK0, m_back0edit);
	DDX_Control(pDX, IDC_FORWARD0, m_forward0edit);
	DDX_Control(pDX, IDC_GUARD0, m_guard0edit);
	DDX_Control(pDX, IDC_PASS0, m_pass0edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKeyboardConfigDialog, CDialog)
	//{{AFX_MSG_MAP(CKeyboardConfigDialog)
	ON_EN_CHANGE(IDC_GUARD0, OnChangeGuard0)
	ON_BN_CLICKED(IDC_GUARD0BUTTON, OnGuard0button)
	ON_BN_CLICKED(IDC_BACK0BUTTON, OnBack0button)
	ON_BN_CLICKED(IDC_FORWARD0BUTTON, OnForward0button)
	ON_BN_CLICKED(IDC_PASS0BUTTON, OnPass0button)
	ON_WM_CREATE()
	ON_WM_KEYUP()
	ON_BN_CLICKED(IDC_GUARD0BUTTON2, OnGuard1button)
	ON_BN_CLICKED(IDC_PASS0BUTTON2, OnPass1button)
	ON_BN_CLICKED(IDC_FORWARD0BUTTON2, OnForward1button)
	ON_BN_CLICKED(IDC_BACK0BUTTON2, OnBack1button)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyboardConfigDialog message handlers

void CKeyboardConfigDialog::OnChangeGuard0() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

/*
void CKeyboardConfigDialog::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{	
	// nedostava zpravy o klavesach!

	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);
}
*/

BOOL CKeyboardConfigDialog::PreTranslateMessage(MSG* pMsg) 
{	
	if (pMsg->message == WM_KEYDOWN)
	{
		int nChar = pMsg->wParam;
		TRACE("KeyDown: %i\n", nChar);
		if (m_choosingPlayer == 0 || m_choosingPlayer == 1)
		{ // cekal jsem na klavesu:
			m_vk[m_choosingPlayer][m_choosingAction] = nChar;
			setEdits();
			m_choosingPlayer = -1;
			return TRUE; // zpravu jsem vyridil
		}		
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CKeyboardConfigDialog::OnGuard0button() 
{
	m_choosingAction = cStreh;	
	m_choosingPlayer = 0;
}

void CKeyboardConfigDialog::OnBack0button() 
{
	m_choosingAction = cOdsun;	
	m_choosingPlayer = 0;
}

void CKeyboardConfigDialog::OnForward0button() 
{
	m_choosingAction = cPosun;	
	m_choosingPlayer = 0;
}

void CKeyboardConfigDialog::OnPass0button() 
{	
	m_choosingAction = cVypad;	
	m_choosingPlayer = 0;	
}

void CKeyboardConfigDialog::setEdits()
{
	m_guard0edit.SetWindowText( CString(m_vk[0][0]) );
	m_back0edit.SetWindowText( CString(m_vk[0][1]) );
	m_forward0edit.SetWindowText( CString(m_vk[0][2]) );
	m_pass0edit.SetWindowText( CString(m_vk[0][3]) );

	m_guard1edit.SetWindowText( CString(m_vk[1][0]) );
	m_back1edit.SetWindowText( CString(m_vk[1][1]) );
	m_forward1edit.SetWindowText( CString(m_vk[1][2]) );
	m_pass1edit.SetWindowText( CString(m_vk[1][3]) );
}

int CKeyboardConfigDialog::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;	
	
	return 0;
}

BOOL CKeyboardConfigDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	setEdits();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CKeyboardConfigDialog::OnOK() 
{
	// volba klaves povtrzena, narvu je do InputManagera:
	for (int h=0; h<2; h++)
	{
		for (int n=0; n<cPocetAkci; n++)
		{
			m_inputManager->setKeyboardConfig(h, n, m_vk[h][n]);
		}
	}
	
	CDialog::OnOK();
}

void CKeyboardConfigDialog::OnGuard1button() 
{	
	m_choosingAction = cStreh;	
	m_choosingPlayer = 1;
}

void CKeyboardConfigDialog::OnPass1button() 
{	
	m_choosingAction = cVypad;	
	m_choosingPlayer = 1;
}

void CKeyboardConfigDialog::OnForward1button() 
{	
	m_choosingAction = cPosun;	
	m_choosingPlayer = 1;
}

void CKeyboardConfigDialog::OnBack1button() 
{
	m_choosingAction = cOdsun;	
	m_choosingPlayer = 1;	
}
