// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "gl1.h"

#include "MainFrm.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_COMMAND(ID_FILE_REPLAY, OnFileReplay)
	ON_COMMAND(ID_FILE_GO, OnFileGo)
	ON_COMMAND(ID_MAIN_ANIMTEST, OnMainAnimtest)
	ON_COMMAND(ID_KEYBOARD, OnKeyboard)
	ON_COMMAND(ID_MAIN_VIEWERCLIENT, OnMainViewerclient)
	ON_COMMAND(ID_NETWORK_DISCONNECT, OnNetworkDisconnect)
	ON_COMMAND(ID_INPUT0_MOUSE, OnInput0Mouse)
	ON_COMMAND(ID_INPUT1_MOUSE, OnInput1Mouse)
	ON_COMMAND(ID_INPUT0_NOTHING, OnInput0Nothing)
	ON_COMMAND(ID_INPUT1_NOTHING, OnInput1Nothing)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame(CGl1App *thisapp)
{
 m_thisapp = thisapp;
 m_wndView = new CChildView(this, thisapp);
}

CMainFrame::~CMainFrame()
{
	delete m_wndView;
}

int CMainFrame::CreateChild(void)
{
    DWORD		dwExStyle = WS_EX_APPWINDOW;				// Window Extended Style
	DWORD		dwStyle = 0;								// Window Style
	CRect		WindowRect(0,0,500,200);				// Grabs Rectangle Upper Left / Lower Right Values	

/*
	if (!*fullscreen)  {
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_CLIPSIBLINGS|WS_CLIPCHILDREN;				// Windows Style
	} else {
		dwExStyle = WS_EX_APPWINDOW;
		dwStyle=0;
	}
*/	

//	::AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size


	if (!m_wndView->CreateEx(dwExStyle, NULL, "Wokno W", 
		    WS_CHILD|dwStyle,
		    WindowRect, this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

 return 0;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
    CreateChild();
	
	// dalsi blbosti
/*
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}		
*/

/*
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
*/

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    cs.dwExStyle = WS_EX_APPWINDOW;
    cs.style = WS_OVERLAPPEDWINDOW;// | CS_HREDRAW | CS_VREDRAW;// | CS_OWNDC;	// Redraw On Size, And Own DC For Window.	
	
	// pozice a velikost celeho hlavniho okna:
	/**/
	cs.x = 700;
	cs.y = 0;
	cs.cx = 300;
	cs.cy = 500;

	cs.lpszClass = AfxRegisterWndClass(0/*CS_HREDRAW | CS_VREDRAW | CS_OWNDC*/, 
	   ::LoadCursor(NULL, IDC_ARROW), NULL, ::LoadIcon(NULL, IDI_ASTERISK));

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	pOldWnd = 0; //anti-warning
	// forward focus to the view window
	m_wndView->SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// If pHandlerInfo is NULL, tak to znamena, ze se zpravu nepovedlo osetrit
	// standardnim mechanismem -> je to dynamicky pridana polozka menu
	if (pHandlerInfo == NULL)
	{		
		if ((nID >= ID_INPUT0_RESERVED0 && nID < ID_INPUT0_RESERVED_LAST) ||
			(nID >= ID_INPUT1_RESERVED0 && nID < ID_INPUT1_RESERVED_LAST) ||
			(nID >= ID_INPUT0_REMOTE0 && nID < ID_INPUT0_REMOTE_LAST) ||
			(nID >= ID_INPUT1_REMOTE0 && nID < ID_INPUT1_REMOTE_LAST))
		{	
			if (nCode == CN_COMMAND)
			{
				// Handle WM_COMMAND message
				OnInputReserved(nID);
			}
			else if (nCode == CN_UPDATE_COMMAND_UI)
			{
				// Update UI element state
				CCmdUI *pcmdui = (CCmdUI*)pExtra;
				pcmdui->Enable();
				//DoUpdateSelectColor(i, (CCmdUI*)pExtra);
			}
			return TRUE;
		}		
	}

	// let the view have first crack at the command
	if (m_wndView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here

    //TRACE("CMainFrame.OnSize %i, %i\n", cx, cy);
}

void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

/*
    CBrush br1;
	br1.CreateSolidBrush(0x00FF00);
	dc.Ellipse(100,100,200,200);
*/

	// Do not call CFrameWnd::OnPaint() for painting messages
}

void CMainFrame::OnFileReplay() 
{	
	if (m_wndView->isConnected())
	{
		MessageBox("Disconnect first.", "Message", MB_OK);
		return;
	}

	m_wndView->initMode(cReplay);
	CMenu *menu = GetMenu();
	UnCheckAll();	
	menu->CheckMenuItem(ID_FILE_REPLAY, MF_CHECKED);	
}

void CMainFrame::OnFileGo() 
{
	if (m_wndView->isConnected())
	{
		MessageBox("Disconnect first.", "Message", MB_OK);
		return;
	}

	m_wndView->initMode(cSimulate);	
	CMenu *menu = GetMenu();
	UnCheckAll();
	menu->CheckMenuItem(ID_FILE_GO, MF_CHECKED);	
}

void CMainFrame::UncheckInput(int i)
{
	CMenu *menu = GetMenu();
	if (i==0)
	{
		menu -> CheckMenuItem(ID_INPUT0_MOUSE, MF_UNCHECKED);	
		menu -> CheckMenuItem(ID_INPUT0_NOTHING, MF_UNCHECKED);	
		for (int n=ID_INPUT0_RESERVED0; n<ID_INPUT0_RESERVED_LAST; n++)
			menu -> CheckMenuItem(n, MF_UNCHECKED);	
		for (n=ID_INPUT0_REMOTE0; n<ID_INPUT0_REMOTE_LAST; n++)
			menu -> CheckMenuItem(n, MF_UNCHECKED);	
	}
	else
	{	
		menu -> CheckMenuItem(ID_INPUT1_MOUSE, MF_UNCHECKED);	
		menu -> CheckMenuItem(ID_INPUT1_NOTHING, MF_UNCHECKED);	
		for (int n=ID_INPUT1_RESERVED0; n<ID_INPUT1_RESERVED_LAST; n++)
			menu -> CheckMenuItem(n, MF_UNCHECKED);
		for (n=ID_INPUT1_REMOTE0; n<ID_INPUT1_REMOTE_LAST; n++)
			menu -> CheckMenuItem(n, MF_UNCHECKED);	
	}	
}

//DEL void CMainFrame::OnInputMouse() 
//DEL {
//DEL 	CMenu *menu = GetMenu();
//DEL 	menu -> CheckMenuItem(ID_INPUT_MOUSE, MF_CHECKED);
//DEL 	menu -> CheckMenuItem(ID_INPUT_JOYSTICK, MF_UNCHECKED);		
//DEL 
//DEL //	m_wndView->selectInput(1);
//DEL }

void CMainFrame::OnInput0Mouse() 
{
	OnInputReserved(ID_INPUT0_MOUSE);
}

void CMainFrame::OnInput1Mouse() 
{
	OnInputReserved(ID_INPUT1_MOUSE);
}

void CMainFrame::OnInput0Nothing() 
{
	OnInputReserved(ID_INPUT0_NOTHING);	
}

void CMainFrame::OnInput1Nothing() 
{
	OnInputReserved(ID_INPUT1_NOTHING);
}

void CMainFrame::OnInputReserved(int id)
{	
	int group = 0, code = 0;
	bool remote = false;
	if (id>=ID_INPUT0_RESERVED0 && id<ID_INPUT0_RESERVED_LAST) 
	{ 
		group = 0; 
		code = id - ID_INPUT0_RESERVED0; 
	}
	else if (id>=ID_INPUT1_RESERVED0 && id<ID_INPUT1_RESERVED_LAST) 
	{ 
		group = 1; 
		code = id - ID_INPUT1_RESERVED0; 
	}
	else if (id>=ID_INPUT0_REMOTE0 && id<ID_INPUT0_REMOTE_LAST) 
	{ 
		group = 0; 
		code = id - ID_INPUT0_REMOTE0; 
		remote = true;
	}
	else if (id>=ID_INPUT1_REMOTE0 && id<ID_INPUT1_REMOTE_LAST) 
	{ 
		group = 1; 
		code = id - ID_INPUT1_REMOTE0; 
		remote = true;
	}
	else if (id==ID_INPUT0_MOUSE) 
	{ 
		group = 0; code = -1;
	}
	else if (id==ID_INPUT1_MOUSE) 
	{
		group = 1; code = -1;
	}
	else if (id==ID_INPUT0_NOTHING)
	{
		group = 0; code = -2;
	}
	else if (id==ID_INPUT1_NOTHING)
	{
		group = 1; code = -2;
	}
	else assert(false);

	TRACE("CMainFrame::OnInputReserved %i, group %i, code = %i, remote = %i\n", id, group, code, remote);

	if (GetMenu()->CheckMenuItem(id, MF_CHECKED) == MF_CHECKED)
	{ // vybrano uz jednou zaskrtnute -> chci nastavovat butony joysticku (je-li to)
		TRACE("vybrano zaskrtnute\n");
		if (!remote && code >= 0)
		{ // je to joystick:
			m_wndView->OnButtonSelect(code);
		}
	}
	else
	{ // vybrano nezaskrtnute -> zmena:
		UncheckInput(group);
		GetMenu()->CheckMenuItem(id, MF_CHECKED);
		m_wndView->setInputDevice(group, code, remote);
	}
}

void CMainFrame::OnMainAnimtest() 
{
	if (m_wndView->isConnected())
	{
		MessageBox("Disconnect first.", "Message", MB_OK);
		return;
	}
	
	m_wndView->initMode(cAnimTest);
	CMenu *menu = GetMenu();
	UnCheckAll();
	menu->CheckMenuItem(ID_MAIN_ANIMTEST, MF_CHECKED);	
}

void CMainFrame::OnKeyboard() 
{	
	m_kbdDialog = new CKeyboardConfigDialog(m_wndView->getInputManager());
	m_kbdDialog->DoModal();
	delete m_kbdDialog;
}

void CMainFrame::OnMainViewerclient() 
{
	if (m_wndView->isConnected())
	{
		MessageBox("Disconnect first.", "Message", MB_OK);
		return;
	}
	
	m_wndView->initMode(cViewer);
	CMenu *menu = GetMenu();
	UnCheckAll();
	menu->CheckMenuItem(ID_MAIN_VIEWERCLIENT, MF_CHECKED);
}

void CMainFrame::UnCheckAll()
{
	CMenu *menu = GetMenu();
	menu->CheckMenuItem(ID_FILE_GO, MF_UNCHECKED);
	menu->CheckMenuItem(ID_FILE_REPLAY, MF_UNCHECKED);
	menu->CheckMenuItem(ID_MAIN_ANIMTEST, MF_UNCHECKED);
	menu->CheckMenuItem(ID_MAIN_VIEWERCLIENT, MF_UNCHECKED);
}

void CMainFrame::DisableAll()
{
	GetMenu()->EnableMenuItem(ID_FILE_GO, MF_GRAYED);
	GetMenu()->EnableMenuItem(ID_FILE_REPLAY, MF_GRAYED);
	GetMenu()->EnableMenuItem(ID_MAIN_ANIMTEST, MF_GRAYED);
	GetMenu()->EnableMenuItem(ID_MAIN_VIEWERCLIENT, MF_GRAYED);	
}

void CMainFrame::OnNetworkDisconnect() 
{
	m_wndView->Disconnect();
}

// vrati ukazatel na podmenu, ktere obsahuje jako prvni polozku identifikator 'id',
// nebo NULL pokud neexistuje:
CMenu * CMainFrame::getSubMenu(int id)
{
  CMenu* pTopMenu = GetMenu();
  int iPos;
  for (iPos = pTopMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
  {
		CMenu* pMenu = pTopMenu->GetSubMenu(iPos);
		if (pMenu && (int)pMenu->GetMenuItemID(0) == id)	return pMenu;					
  }
  return 0;
}

//DEL void CMainFrame::setInput0Mouse()
//DEL {
//DEL 	OnInput0Mouse();
//DEL }

//DEL void CMainFrame::setInput1Mouse()
//DEL {
//DEL 	OnInput1Mouse();
//DEL }

void CMainFrame::setInput(int id)
{
	OnInputReserved(id);
}

//DEL void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
//DEL {
//DEL 	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
//DEL 	int n;
//DEL 	CString txt;
//DEL 
//DEL 	if (nIndex == 2) // 2 je Input0 (blby Wokna, taky to nemuzou nejak nazvat!)
//DEL 	{
//DEL 		for (n=ID_INPUT0_REMOTE0; n<ID_INPUT0_REMOTE_LAST; n++)
//DEL 			pPopupMenu->DeleteMenu(n, MF_BYCOMMAND);		
//DEL 
//DEL 		if (m_wndView->getSS())
//DEL 		{
//DEL 			for (n=ID_INPUT0_REMOTE0; n<ID_INPUT0_REMOTE_LAST; n++)
//DEL 			{
//DEL 				if (m_wndView->getSS()->getClientString(n-ID_INPUT0_REMOTE0, txt))
//DEL 					pPopupMenu->AppendMenu(MF_STRING, n, txt);
//DEL 			}
//DEL 		}
//DEL 		DrawMenuBar();
//DEL 	}
//DEL 	if (nIndex == 3) // 3 je Input1 (blby Wokna, taky to nemuzou nejak nazvat!)
//DEL 	{
//DEL 		for (n=ID_INPUT1_REMOTE0; n<ID_INPUT1_REMOTE_LAST; n++)
//DEL 			pPopupMenu->DeleteMenu(n, MF_BYCOMMAND);		
//DEL 	}
//DEL 	
//DEL }

//DEL void CMainFrame::actualizeMenu()
//DEL {
//DEL 	CMenu *inputMenu[2];
//DEL 	inputMenu[0] = getSubMenu(ID_INPUT0_NOTHING);
//DEL 	inputMenu[1] = getSubMenu(ID_INPUT1_NOTHING);
//DEL 	assert(inputMenu[0] && inputMenu[1]);
//DEL 	
//DEL 	CString txt;
//DEL 	// pro hrace 0:
//DEL 	for (int n=ID_INPUT0_REMOTE0; n<ID_INPUT0_REMOTE_LAST; n++)
//DEL 		inputMenu[0]->DeleteMenu(n, MF_BYCOMMAND);		
//DEL 	for (n=ID_INPUT0_REMOTE0; n<ID_INPUT0_REMOTE_LAST; n++)
//DEL 	{
//DEL 		if (m_wndView->getSS()->getClientString(n-ID_INPUT0_REMOTE0, txt))
//DEL 			inputMenu[0]->AppendMenu(MF_STRING, n, txt);
//DEL 	}
//DEL 	// pro hrace 1:
//DEL 	for (n=ID_INPUT1_REMOTE0; n<ID_INPUT1_REMOTE_LAST; n++)
//DEL 		inputMenu[1]->DeleteMenu(n, MF_BYCOMMAND);		
//DEL 	for (n=ID_INPUT1_REMOTE0; n<ID_INPUT1_REMOTE_LAST; n++)
//DEL 	{
//DEL 		if (m_wndView->getSS()->getClientString(n-ID_INPUT0_REMOTE0, txt))
//DEL 			inputMenu[0]->AppendMenu(MF_STRING, n, txt);
//DEL 	}
//DEL }

void CMainFrame::addToMenus(int code, CString txt)
{
	CMenu *inputMenu[2];
	inputMenu[0] = getSubMenu(ID_INPUT0_NOTHING);
	inputMenu[1] = getSubMenu(ID_INPUT1_NOTHING);
	assert(inputMenu[0] && inputMenu[1]);
	
	// do obou men pridavame to samy:
	for (int m=0; m<2; m++)
	{
		if (ID_INPUT_REMOTE0[m] + code >= ID_INPUT_REMOTE_LAST[m]) 
		{
			TRACE("addToMenus: nevejde se do menu %i, sorry\n", m);
			return;
		}
		inputMenu[m]->AppendMenu(MF_STRING, ID_INPUT_REMOTE0[m] + code, txt);
	}
}

void CMainFrame::delFromMenus(int code)
{
	CMenu *inputMenu[2];
	inputMenu[0] = getSubMenu(ID_INPUT0_NOTHING);
	inputMenu[1] = getSubMenu(ID_INPUT1_NOTHING);
	assert(inputMenu[0] && inputMenu[1]);

	// z obou men mazeme to samy:
	for (int m=0; m<2; m++)
	{
		if (ID_INPUT_REMOTE0[m] + code >= ID_INPUT_REMOTE_LAST[m]) 
		{
			TRACE("delFromMenus: mimo reservedy, sorry\n");
			return;
		}
		if ((inputMenu[m]->GetMenuState(ID_INPUT_REMOTE0[m] + code, MF_BYCOMMAND)) & MF_CHECKED)
		{
			if (m==0)
				MessageBox("Client controlling avatar 0 has closed the connection - I'm setting its input to 'Nothing'", "Notification");
		    else if (m==1)
				MessageBox("Client controlling avatar 1 has closed the connection - I'm setting its input to 'Nothing'", "Notification");
			else assert(false);
			OnInputReserved(ID_INPUT_NOTHING[m]); // nastavime nothing...
		}
		inputMenu[m]->DeleteMenu(ID_INPUT_REMOTE0[m] + code, MF_BYCOMMAND);
	}
}

//DEL void CMainFrame::OnButtonreset() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	TRACE("reset (mainframe)\n");
//DEL }
