// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__0A8F5E17_0AEE_43B0_951E_C50FBEB46A42__INCLUDED_)
#define AFX_MAINFRM_H__0A8F5E17_0AEE_43B0_951E_C50FBEB46A42__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"
#include "KeyboardConfigDialog.h"
#include "gl1.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame(CGl1App *thisapp);
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
protected:	
	CGl1App *m_thisapp;
public:

// Operations
protected:
	int CreateChild(void);
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

public:
	void delFromMenus(int code);
	void addToMenus(int code, CString txt);
	void setInput(int id);
	void UncheckInput(int i);
	void OnInputReserved(int idx);
	CMenu * getSubMenu(int idx);
	void DisableAll();
	void UnCheckAll();
	CChildView    *m_wndView;
	void setStatusText(char *txt) { m_wndStatusBar.SetWindowText(txt); }
	// funkce co bude zavolana hned po vytvoreni okna MainFrame:
	void afterWindowCreation()
	{
		m_wndView->afterWindowCreation();
	}

// Generated message map functions
protected:
	CKeyboardConfigDialog *m_kbdDialog;
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnFileReplay();
	afx_msg void OnFileGo();
	afx_msg void OnMainAnimtest();
	afx_msg void OnKeyboard();
	afx_msg void OnMainViewerclient();
	afx_msg void OnNetworkDisconnect();
	afx_msg void OnInput0Mouse();
	afx_msg void OnInput1Mouse();
	afx_msg void OnInput0Nothing();
	afx_msg void OnInput1Nothing();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__0A8F5E17_0AEE_43B0_951E_C50FBEB46A42__INCLUDED_)
