/* 
    MainMode.h

	Abstract class for the main loop.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#ifndef MAINMODE_H
#define MAINMODE_H

#include "LocalRemoteModel.h"
#include "CameraView.h"

class CMainMode {
public:
	virtual ~CMainMode() {}
	virtual void play() = 0;
	virtual void draw(CCameraView *camera, int camId, const bool transpAvatar[2]) = 0;	
	virtual void reloadTextures(int camId) = 0;
	virtual FencerModel *getModel(int i) = 0;
	virtual int getMyState() = 0;
};

#endif