/*
	MilkshapeModel.h

		Loads and renders a Milkshape3D model. 

	Author:	Brett Porter
	Email: brettporter@yahoo.com
	Website: http://www.geocities.com/brettporter/
	Copyright (C)2000, Brett Porter. All Rights Reserved.

	This file may be used only as long as this copyright notice remains intact.
*/

/*

	Modifications by Ladislav Kavan, 2002

*/

#ifndef MILKSHAPEMODEL_H
#define MILKSHAPEMODEL_H

#include "Model.h"

class MilkshapeModel : public Model
{
	public:
		/*	Constructor. */
		MilkshapeModel();

		/*	Destructor. */
		virtual ~MilkshapeModel();

		/*	
			Load the model data into the private variables. 
				filename			Model filename
		*/
		virtual bool loadModelData( const char *filename );
		// Nastavi modelu obecnejsi prirazeni vrcholu kostem, nez uklada MS3D
		virtual bool loadWeights(const char *filename);
		// Nahraje spravne normaly
		virtual bool loadNormals(const char *filename);
		// Save model data in MS3D ASCII format
		virtual void saveModelData( const char *filename );
		// Save mesh data in VolInt format, assuimg one mesh:
		void saveModelVolInt( const char *filename );

};

#endif // ndef MILKSHAPEMODEL_H