/* 
    ModeAnimTest.cpp

	Implementation of CMainMode abstract class for the testing of animation.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#include "stdafx.h"
#include "ModeAnimTest.h"
#include "gl1.h"
#include "MainFrm.h"
#include <assert.h>

void CModeAnimTest::play()
{
	m_inputManager->pollDevices();

	m_locModel->updateModel(0, NULL);
	m_locModel->m_model->compActVers();	
}

void CModeAnimTest::init(int quality)
{
	m_dbgDialog->rebuild = true;
	m_locModel = new LocalModel(0, 0, 0, quality);
	m_locModel->setRootTrans(0);

	m_inputManager->setLocModels(m_locModel, 0); // 2. je NULL
}

CModeAnimTest::~CModeAnimTest()
{
	delete m_locModel;
}

void CModeAnimTest::draw(CCameraView *camera, int camId, const bool transpAvatar[2])
{
	float trval = (float)m_dbgDialog->m_slider.GetPos() / m_dbgDialog->m_slider.GetRangeMax();
	float tr[2] = {-1, -1};
	if (transpAvatar[0]) tr[0] = trval;
	if (transpAvatar[1]) tr[1] = trval;

	m_locModel->m_model->draw(camId, false, m_drawFadingTriangles, tr[0]);
	m_locModel->m_model->getWeapon()->draw(camId, false, m_drawFadingTriangles, tr[0]);

	camera->setText((const char *)0);
	camera->setScore((const char *)0);
}

void CModeAnimTest::reloadTextures(int camId)
{
	m_locModel->m_model->reloadTextures(camId);
}

FencerModel *CModeAnimTest::getModel(int i)
{
	TRACE("Warning: nekdo se pta na model (c. %i) od CModeAnimTest\n", i);
	return m_locModel;
}