/* 
    ModeAnimTest.h

	Implementation of CMainMode abstract class for the test of animation.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#include "MainMode.h"
#include "LocalRemoteModel.h"
#include "InputManager.h"
#include "gl1.h"
#include "DebugDialog.h"
#include "constants.h"

#ifndef MODEAnimTest_H
#define MODEAnimTest_H

class CModeAnimTest : public CMainMode
{
protected:
// to si vyrobim:
	LocalModel	*m_locModel; // jen jeden!
	bool		 m_drawFadingTriangles;

// na to mam jen ukazatel:	
	InputManager	*m_inputManager;
	CFrameWnd		*m_owner;
	DebugDialog		*m_dbgDialog;	

public:
	CModeAnimTest(InputManager *im, CFrameWnd *owner, 
		DebugDialog *dd, int quality) : m_inputManager(im), m_owner(owner), m_dbgDialog(dd)
	{
		init(quality);
		m_drawFadingTriangles = true; 		
	}
	virtual void init(int quality);
	virtual ~CModeAnimTest();
	virtual void play();
	virtual void draw(CCameraView *camera, int camId, const bool transpAvatar[2]);		
	virtual void reloadTextures(int camId);
	virtual FencerModel *getModel(int i);
	virtual int getMyState() { return cAnimTest; }
//	virtual void changeQuality(int quality) { assert(false); }
};

#endif MODEAnimTest_H