/* 
    ModeReplay.h

	Implementation of CMainMode abstract class for the replay of saved simulation.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#include "MainMode.h"
#include "LocalRemoteModel.h"
#include "AnimSequence.h"
//#include "InputManager.h"
#include "gl1.h"
#include "DebugDialog.h"
//#include "Communication.h"
#include "constants.h"

#ifndef MODEREPLAY_H
#define MODEREPLAY_H

class CModeReplay : public CMainMode
{
protected:
// to si vyrobim:
	RemoteModel	*m_remoteModel[2];	
	AnimLoader	*m_animLoader;	
	//bool *m_pTr[2]; // kolidujici trojuhelniky obou sermiru	
	int			m_lastRec;
	bool		m_drawFadingTriangles;

// na to mam jen ukazatel:	
	CFrameWnd		*m_owner;
	DebugDialog		*m_dbgDialog;	

// dalsi promenne:
	const char *m_judgeText, *m_judgeScore;

public:
	CModeReplay(CFrameWnd *owner, DebugDialog *dd) : m_owner(owner), m_dbgDialog(dd)
	{ 
		init(); 
		m_lastRec = -1; 
		m_drawFadingTriangles = false;//true;
	}
	virtual void init();
	virtual ~CModeReplay();
	virtual void play();
	virtual void draw(CCameraView *camera, int camId, const bool transpAvatar[2]);
	virtual void reloadTextures(int camId);
	virtual FencerModel *getModel(int i);
	virtual int getMyState() { return cReplay; }
//	virtual void changeQuality(int quality) { assert(false); }
};

#endif MODEREPLAY_H