/* 
    ModeViewer.h

	Implementation of CMainMode abstract class for the viewing of remote simulation.

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#include "MainMode.h"
#include "LocalRemoteModel.h"
#include "InputManager.h"
#include "gl1.h"
#include "DebugDialog.h"
#include "Communication.h"
#include "constants.h"

#ifndef MODEViewer_H
#define MODEViewer_H

class CModeViewer : public CMainMode
{
protected:
// to si vyrobim:
	RemoteModel	*m_remoteModel[2];	
	//bool *m_pTr[2]; // kolidujici trojuhelniky obou sermiru	
	int			m_lastRec;
	bool		m_drawFadingTriangles;
	CString		m_score; // zobrazuje se v kamere, nastavuje se ze zprav JudgeMsg pmci setTexts
	CString		m_msg;
	Win32Timer	m_timer; // kvuli leceni trojuhelniku

// na to mam jen ukazatel:	
	CFrameWnd		*m_owner;
	DebugDialog		*m_dbgDialog;
	CCommSocket		**m_cs;
	InputManager	*m_inputManager;

public:
	CModeViewer(InputManager *im, CFrameWnd *owner, DebugDialog *dd, CCommSocket **cs, int quality) : 
		m_inputManager(im), m_owner(owner), m_dbgDialog(dd), m_cs(cs)
	{ 
		init(quality); 
		m_lastRec = -1; 
		m_drawFadingTriangles = true;
	}
	virtual void init(int quality);
	virtual ~CModeViewer();
	virtual void play();
	virtual void draw(CCameraView *camera, int camId, const bool transpAvatar[2]);
	virtual void reloadTextures(int camId);
	virtual FencerModel *getModel(int i);
	virtual int getMyState() { return cViewer; }
//	virtual void changeQuality(int quality) { assert(false); }
	void setTexts(const char *score, const char *msg)
	{
		m_score = score; m_msg = msg;
	}
};

#endif MODEViewer_H