/* 
    geometry.h

	Auxiliary geometric routines

    Author: Ladislav Kavan, 2002
	E-mail: lkav8604@barbora.ms.mff.cuni.cz
*/

#ifndef GEOMETRY_H
#define GEOMETRY_H

#define GEOM_EPSILON 0.0001

// odsoupne bod B0 od bodu A0 ve smeru s na vzdalenost D; vraci o kolik je treba
// posunout B0 ve smeru s (kladne!) (12.2.02); neexistuje-li reseni, vraci -1
float sepPoints(const float A0[3], const float B0[3], const float s[3], float D);

// res = (1-t)*A + t*B
void linterpvect(float res[3], const float A[3], const float B[3], float t);

// vraci vzdalenost mezi body A a B
float distPointPoint(const float A[3], const float B[3]);

// vraci vzdalenost mezi useckou danou body M, P a bodem N
// a nastavuje bod na usecce B, kde se minima nabyva
float distSegPoint(const float M[3], const float P[3], const float N[3], float B[3]);

// vraci vzdalenost mezi useckou danou body A, B a
// useckou danou body C, D; nastavuje body X, Y kde lezi minimalni pricka
// vraci -1 jsou-li usecky rovnobezne
float distSegSeg(const float A[3], const float B[3], const float C[3], const float D[3], 
				 float X[3], float Y[3]);

// self-test
void geometry_test();

#endif